# coding: utf-8
import datetime
import autopath
from os.path import join
import subprocess
from copy import copy
from bson.objectid import ObjectId

from eoleaaf.util import db
from eoleaaf.parseaaf import main
from eoleaaf.parsedelta import main as main_delta
from eoleaaf.aaf import reset_db

def setup_function(module, ):
    reset_db()


data = join(autopath.HERE, 'data', '20170704')

data_complet = join(data, 'aaf-complet')
data_delta = join(data, 'aaf-delta')


eleve = {u"ENTPersonJointure": "22357",
         u"ENTEleveStructRattachId": "436201",
         u"ENTPersonDateNaissance": "28/11/1914",
         u"ENTPersonNomPatro": "DELACOURT",
         u"sn": "DELACOURT",
         u"ENTPersonLogin": "geraldine.delacourt01",
         u'FieldActionType': 'DELTACREATE',
         u'FieldModifiedStatus': 1,
         u'UserType': "eleve",
         u"givenName": "Geraldine",
         u"ENTPersonAutresPrenoms": [u"Geraldine", u"Pauline"],
         u"personalTitle": "Mme.",
#         u"ENTEleveParents": [u"994845", u"994846"],
#         u"ENTElevePere": "994845",
#         u"ENTEleveMere": "994846",
#         u"ENTEleveAutoriteParentale": [u"994845", u"994846"],
         u"ENTElevePersRelEleve1": '',
         u"ENTEleveQualitePersRelEleve1": '',
         u"ENTElevePersRelEleve2": '',
         u"ENTEleveQualitePersRelEleve2": '',
         #FIXME donnee brute utile a extraire ? => http://media.eduscol.education.fr/file/ENT/27/9/Documentation-solutionsENT-evolutionsAAF-SDETv4_238279.pdf
         u"ENTElevePersRelEleve": [u"994845$1$0$2$1$0", u"994846$2$1$1$1$0"],
         u"ENTEleveBoursier": "O",
         u"ENTEleveRegime": "EXTERNE LIBRE",
         u"ENTEleveTransport": "N",
         u"ENTEleveStatutEleve": "SCOLAIRE",
         u"ENTEleveMEF": "21220008113",
         u"ENTEleveLibelleMEF": "T-STL SC.PHYS.CHIM. EN LABORATOIRE",
         u"ENTEleveNivFormation": "TERMINALE GENERALE & TECHNO YC BT",
         u"ENTEleveFiliere": "TERMINALE TECHNOLOGIQUE",
         u"ENTEleveEnseignements": [u"PHILOSOPHIE", u"CHIMIE, BIOCHIMIE, SCIENCES DU VIVANT", u"ENSEIGNEMENT TECHNOLOGIQUE EN LV1", u"SCIENCES PHYSIQUES ET CHIMIQUES EN LABO.", u"VIE DE CLASSE", u"ACCOMPAGNEMENT PERSONNALISE", u"ANGLAIS LV1", u"EDUCATION PHYSIQUE ET SPORTIVE", u"ESPAGNOL LV2", u"MATHEMATIQUES", u"PHYSIQUE-CHIMIE"],
         u"ENTEleveCodeEnseignements": ["010300", u"308600"],
         #u"ENTPersonStructRattach": "2515",
         #u"ENTEleveClasses": "2515$T STL",
         u"ENTEleveGroupes": [],
         u"gecos": "Geraldine DELACOURT",
         u"homedirectory": '\\\\FILE.DOMSETH.AC-TEST.FR\\geraldine.delacourt01\\perso',
         u"profilepath": '\\\\FILE.DOMSETH.AC-TEST.FR\\geraldine.delacourt01\\profil',
         }

eleve2 = {u"ENTPersonJointure": "14357",
         u"ENTEleveStructRattachId": "436201",
         u"ENTPersonDateNaissance": "28/11/1914",
         u"ENTPersonNomPatro": "DELACOURT",
         u"sn": "DELACOURT",
         u"ENTPersonLogin": "albertine.delacourt02",
         u'FieldActionType': 'DELTAUPDATE',
         u'FieldModifiedStatus': 1,
         u'UserType': "eleve",
         u"givenName": "Albertine",
         u"ENTPersonAutresPrenoms": [u"Albertine", u"Pauline"],
         u"personalTitle": "Mme.",
#         u"ENTEleveParents": [u"994845", u"994846"],
#         u"ENTElevePere": "994845",
#         u"ENTEleveMere": "994846",
#         u"ENTEleveAutoriteParentale": [u"994845", u"994846"],
         u"ENTElevePersRelEleve1": '',
         u"ENTEleveQualitePersRelEleve1": '',
         u"ENTElevePersRelEleve2": '',
         u"ENTEleveQualitePersRelEleve2": '',
         #FIXME donnee brute utile a extraire ? => http://media.eduscol.education.fr/file/ENT/27/9/Documentation-solutionsENT-evolutionsAAF-SDETv4_238279.pdf
         u"ENTElevePersRelEleve": [u"994845$1$0$2$1$0", u"994846$2$1$1$1$0"],
         u"ENTEleveBoursier": "O",
         u"ENTEleveRegime": "INTERNE PAS LIBRE",
         u"ENTEleveTransport": "N",
         u"ENTEleveStatutEleve": "SCOLAIRE",
         u"ENTEleveMEF": "21220008110",
         u"ENTEleveLibelleMEF": "T-STL SC.PHYS.CHIM. EN LABORATOIRE",
         u"ENTEleveNivFormation": "TERMINALE GENERALE & TECHNO YC BT",
         u"ENTEleveFiliere": "TERMINALE TECHNOLOGIQUE",
         u"ENTEleveEnseignements": [u"PHILOSOPHIE", u"CHIMIE, BIOCHIMIE, SCIENCES DU VIVANT", u"ENSEIGNEMENT TECHNOLOGIQUE EN LV1", u"SCIENCES PHYSIQUES ET CHIMIQUES EN LABO.", u"VIE DE CLASSE", u"ACCOMPAGNEMENT PERSONNALISE", u"ANGLAIS LV1", u"EDUCATION PHYSIQUE ET SPORTIVE", u"ESPAGNOL LV2", u"MATHEMATIQUES", u"PHYSIQUE-CHIMIE"],
         u"ENTEleveCodeEnseignements": ["010300", u"308600"],
         #u"ENTPersonStructRattach": "2515",
         #u"ENTEleveClasses": "2515$T STL",
         u"ENTEleveGroupes": [],
         u"gecos": "Albertine DELACOURT",
         u"homedirectory": '\\\\FILE.DOMSETH.AC-TEST.FR\\albertine.delacourt02\\perso',
         u"profilepath": '\\\\FILE.DOMSETH.AC-TEST.FR\\albertine.delacourt02\\profil',
         }

eleve3 = {u"ENTPersonJointure": "23357",
         u"ENTEleveStructRattachId": "436201",
         u"ENTPersonDateNaissance": "28/11/1914",
         u"ENTPersonNomPatro": "DELACOURT",
         u"sn": "DELACOURT",
         u"ENTPersonLogin": "theodulette.delacourt01",
         u'FieldActionType': 'DELTACREATE',
         u'FieldModifiedStatus': 1,
         u'UserType': "eleve",
         u"givenName": "Theodulette",
         u"ENTPersonAutresPrenoms": [u"Theodulette", u"Pauline"],
         u"personalTitle": "Mme.",
#         u"ENTEleveParents": [u"994845", u"994846"],
#         u"ENTElevePere": "994845",
#         u"ENTEleveMere": "994846",
#         u"ENTEleveAutoriteParentale": [u"994845", u"994846"],
         u"ENTElevePersRelEleve1": '',
         u"ENTEleveQualitePersRelEleve1": '',
         u"ENTElevePersRelEleve2": '',
         u"ENTEleveQualitePersRelEleve2": '',
         #FIXME donnee brute utile a extraire ? => http://media.eduscol.education.fr/file/ENT/27/9/Documentation-solutionsENT-evolutionsAAF-SDETv4_238279.pdf
         u"ENTElevePersRelEleve": [u"994845$1$0$2$1$0", u"994846$2$1$1$1$0"],
         u"ENTEleveBoursier": "O",
         u"ENTEleveRegime": "INTERNE PAS LIBRE",
         u"ENTEleveTransport": "N",
         u"ENTEleveStatutEleve": "SCOLAIRE",
         u"ENTEleveMEF": "77720008110",
         u"ENTEleveLibelleMEF": "T-STL SC.PHYS.CHIM. EN LABORATOIRE",
         u"ENTEleveNivFormation": "TERMINALE GENERALE & TECHNO YC BT",
         u"ENTEleveFiliere": "TERMINALE TECHNOLOGIQUE",
         u"ENTEleveEnseignements": [u"PHILOSOPHIE", u"CHIMIE, BIOCHIMIE, SCIENCES DU VIVANT", u"ENSEIGNEMENT TECHNOLOGIQUE EN LV1", u"SCIENCES PHYSIQUES ET CHIMIQUES EN LABO.", u"VIE DE CLASSE", u"ACCOMPAGNEMENT PERSONNALISE", u"ANGLAIS LV1", u"EDUCATION PHYSIQUE ET SPORTIVE", u"ESPAGNOL LV2", u"MATHEMATIQUES", u"PHYSIQUE-CHIMIE"],
         u"ENTEleveCodeEnseignements": ["010300", u"308600"],
         #u"ENTPersonStructRattach": "2515",
         #u"ENTEleveClasses": "2515$T STL",
         u"ENTEleveGroupes": [],
         u"gecos": "Theodulette DELACOURT",
         u"homedirectory": '\\\\FILE.DOMSETH.AC-TEST.FR\\theodulette.delacourt01\\perso',
         u"profilepath": '\\\\FILE.DOMSETH.AC-TEST.FR\\theodulette.delacourt01\\profil',
         }

eleves = {u'21220008113': eleve,
          u'21220008110': eleve2,
          u'77720008110': eleve3,}

responsable = {u"ENTPersonJointure": "994854",
               u"ENTPersonDateNaissance": '',
               u"ENTPersonNomPatro": "DELACOURT",
               u"sn": "DELACOURT",
               u"givenName": "Mathieu",
               u"personalTitle": "M",
               u"homePhone": "+33 0 00 11 22 33",
               u"telephoneNumber": '',
               u"ENTPersonAdresse": "2 ROUTE DE CHARTRES",
               u"ENTPersonCodePostal": "75000",
               u"ENTPersonVille": "PARIS",
               u"ENTPersonPays": "FRANCE",
#GENERATE
               u"ENTPersonLogin": "mathieu.delacourt03",
               u"homedirectory": None,
               u"profilepath": None,
#ADDED
               u'FieldActionType': 'DELTACREATE',
               u'FieldModifiedStatus': 1,
               u'UserType': "responsable",
               u"gecos": "Mathieu DELACOURT",
}


responsable2 = {u"ENTPersonJointure": "994845",
               u"ENTPersonDateNaissance": '',
               u"ENTPersonNomPatro": "DELACOURT",
               u"sn": "DELACOURT",
               u"givenName": "Mathieu",
               u"personalTitle": "M",
               u"homePhone": "+33 0 00 11 22 34",
               u"telephoneNumber": '',
               u"ENTPersonAdresse": "2 ROUTE DE CHARTRES",
               u"ENTPersonCodePostal": "75001",
               u"ENTPersonVille": "PARIS",
               u"ENTPersonPays": "FRANCE",
#GENERATE
               u"ENTPersonLogin": "mathieu.delacourt01",
               u"homedirectory": None,
               u"profilepath": None,
#ADDED
               u'FieldActionType': 'DELTAUPDATE',
               u'FieldModifiedStatus': 1,
               u'UserType': "responsable",
               u"gecos": "Mathieu DELACOURT",
}

responsables = {u'994854': responsable,
                u'994845': responsable2,
}


prof = {
    u"ENTPersonJointure": "136",
    u"ENTPersonDateNaissance": "06/01/1918",
    u"ENTPersonNomPatro": "DELMUIRE",
    u"ENTPersonLogin": "ghislaine.delmuire01",
    u'FieldActionType': 'DELTACREATE',
    u'FieldModifiedStatus': 1,
    u'UserType': 'enseignant',
    u"sn": "DELMUIRE",
    u"givenName": "Ghislaine",
    u"personalTitle": "Mme",
    u"mail": "ghislaine.delmuire@ac-test.fr",
    u"ENTAuxEnsCategoDiscipline": "LANGUES VIVANTES",
    u"ENTAuxEnsDisciplinesPoste": "ANGLAIS",
    u"PersEducNatPresenceDevantEleves": "O",
    u"gecos": "Ghislaine DELMUIRE",
    u"homedirectory": '\\\\FILE.DOMSETH.AC-TEST.FR\\ghislaine.delmuire01\\perso',
    u"profilepath":   '\\\\FILE.DOMSETH.AC-TEST.FR\\ghislaine.delmuire01\\profil',
    }

prof2 = {
    u"ENTPersonJointure": "163",
    u"ENTPersonDateNaissance": "06/01/1919",
    u"ENTPersonNomPatro": "DELMARE",
    u"ENTPersonLogin": "ghislaine.delmare01",
    u'FieldActionType': 'DELTAUPDATE',
    u'FieldModifiedStatus': 1,
    u'UserType': 'enseignant',
    u"sn": "DELMARE",
    u"givenName": "Ghislaine",
    u"personalTitle": "Mme",
    u"mail": "ghislaine.delmare@ac-test.fr",
    u"ENTAuxEnsCategoDiscipline": "LANGUES VIVANTES",
    u"ENTAuxEnsDisciplinesPoste": "ANGLAIS",
    u"PersEducNatPresenceDevantEleves": "O",
    u"gecos": "Ghislaine DELMARE",
    u"homedirectory": '\\\\FILE.DOMSETH.AC-TEST.FR\\ghislaine.delmare01\\perso',
    u"profilepath":   '\\\\FILE.DOMSETH.AC-TEST.FR\\ghislaine.delmare01\\profil',
    }

prof3 = {
    u"ENTPersonJointure": "164",
    u"ENTPersonDateNaissance": "06/01/1918",
    u"ENTPersonNomPatro": "DELMARE",
    u"ENTPersonLogin": "ghislaine.delmare02",
    u'FieldActionType': 'DELTACREATE',
    u'FieldModifiedStatus': 1,
    u'UserType': 'enseignant',
    u"sn": "DELMARE",
    u"givenName": "Ghislaine",
    u"personalTitle": "Mme",
    u"mail": "ghislaine.delmare@ac-test.fr",
    u"ENTAuxEnsCategoDiscipline": "LANGUES VIVANTES",
    u"ENTAuxEnsDisciplinesPoste": "ANGLAIS",
    u"PersEducNatPresenceDevantEleves": "O",
    u"gecos": "Ghislaine DELMARE",
    u"homedirectory": '\\\\FILE.DOMSETH.AC-TEST.FR\\ghislaine.delmare02\\perso',
    u"profilepath":   '\\\\FILE.DOMSETH.AC-TEST.FR\\ghislaine.delmare02\\profil',
    }

profs = {
        u'136': prof,
        u'163': prof2,
        u'164': prof3,
        }

administratif = {
    u"ENTPersonJointure": "35",
    u"ENTPersonDateNaissance": "04/09/1985",
    u"ENTPersonNomPatro": "THEODULE",
    u"ENTPersonLogin": "annie.dubled02",
    u'FieldActionType': 'DELTACREATE',
    u'FieldModifiedStatus': 1,
    u'UserType': 'administratif',
    u"sn": "DUBLED",
    u"givenName": "Annie",
    u"personalTitle": "Mme",
    u"mail": "Annie.Dubled@ac-test.fr",
    u"ENTPersonStructRattach": '',
    u"ENTAuxEnsMEF": '',
    u"ENTAuxEnsMatiereEnseignEtab": '',
    u"ENTAuxEnsClasses": '',
    u"ENTAuxEnsClassesMatieres": '',
    #u"ENTPersonFonctions": "2515$ORI$ORIENTATION$O0040$ORIENTATION",
    u"PersEducNatPresenceDevantEleves": "N",
    u"gecos": "Annie DUBLED",
    u"homedirectory": None,
    u"profilepath": None,
}

administratif2 = {
    u"ENTPersonJointure": "34",
    u"ENTPersonDateNaissance": "04/09/1986",
    u"ENTPersonNomPatro": "THEODULE",
    u"ENTPersonLogin": "annie.dubled01",
    u'FieldActionType': 'DELTAUPDATE',
    u'FieldModifiedStatus': 1,
    u'UserType': 'administratif',
    u"sn": "DUBLED",
    u"givenName": "Annie",
    u"personalTitle": "Mme",
    u"mail": "Annie.Dubled@ac-test.fr",
    u"ENTPersonStructRattach": '',
    u"ENTAuxEnsMEF": '',
    u"ENTAuxEnsMatiereEnseignEtab": '',
    u"ENTAuxEnsClasses": '',
    u"ENTAuxEnsClassesMatieres": '',
    #u"ENTPersonFonctions": "2515$ORI$ORIENTATION$O0040$ORIENTATION",
    u"PersEducNatPresenceDevantEleves": "N",
    u"gecos": "Annie DUBLED",
    u"homedirectory": None,
    u"profilepath": None,
}

administratif3 = {
    u"ENTPersonJointure": "36",
    u"ENTPersonDateNaissance": "04/09/1985",
    u"ENTPersonNomPatro": "THEODULE",
    u"ENTPersonLogin": "annie.dubled03",
    u'FieldActionType': 'DELTACREATE',
    u'FieldModifiedStatus': 1,
    u'UserType': 'administratif',
    u"sn": "DUBLED",
    u"givenName": "Annie",
    u"personalTitle": "Mme",
    u"mail": "Annie.Dubled@ac-test.fr",
    u"ENTPersonStructRattach": '',
    u"ENTAuxEnsMEF": '',
    u"ENTAuxEnsMatiereEnseignEtab": '',
    u"ENTAuxEnsClasses": '',
    u"ENTAuxEnsClassesMatieres": '',
    #u"ENTPersonFonctions": "2515$ORI$ORIENTATION$O0040$ORIENTATION",
    u"PersEducNatPresenceDevantEleves": "N",
    u"gecos": "Annie DUBLED",
    u"homedirectory": None,
    u"profilepath": None,
}

administratifs = {
        u'34': administratif2,
        u'35': administratif,
        u'36': administratif3
        }


etablissement = {
    u"ENTStructureJointure": "2516",
    u"ENTStructureUAI": "00000002",
    u"ENTEtablissementUAI": "00000002",
    u"ENTStructureSIREN": "17450234560290",
    u"ENTStructureNomCourant": "D.E.E.E.-DU ac-test",
    u"ENTStructureTypeStruct": "INSPECTIONS ACADEMIQUES",
    u"ENTEtablissementMinistereTutelle": "MINISTERE DE L'EDUCATION NATIONALE",
    u"ENTEtablissementContrat": "PU",
    u'FieldActionType': 'DELTACREATE',
    u'FieldModifiedStatus': 1,
    u"postOfficeBox": "608",
    u"street": "RUE CITE",
    u"postalCode": "18013",
    u"l": "DIJON CEDEX",
    'etab_name': '00000002',
    u"telephoneNumber": "+33 211 25 687  00",
    u"facsimileTelephoneNumber": "+33 2 125899 20 01",
    u"ENTEtablissementStructRattachFctl": '',
    u"ENTEtablissementBassin": "BASSIN DU TEST",
    u"ENTServAcAcademie": "ac test",
    u"ENTStructureClasses": '',
    u"ENTStructureGroupes": [{'class': '4E3', 'group': '4E3_A'}, {'class': '4E3', 'group': '4E3_B'}],
}

etablissement2 = {
    u"ENTStructureJointure": "2515",
    u"ENTStructureUAI": "00000001",
    u"ENTEtablissementUAI": "00000001",
    u"ENTStructureSIREN": "17450234560289",
    u"ENTStructureNomCourant": "D.E.E.E.-DU ac-test",
    u"ENTStructureTypeStruct": "INSPECTIONS ACADEMIQUES",
    u"ENTEtablissementMinistereTutelle": "MINISTERE DE L'EDUCATION NATIONALE",
    u"ENTEtablissementContrat": "PU",
    u'FieldActionType': 'DELTAUPDATE',
    u'FieldModifiedStatus': 1,
    u"postOfficeBox": "608",
    u"street": "RUE CITE",
    u"postalCode": "18013",
    u"l": "DIJON CEDEX",
    'etab_name': 'file.domseth.ac-test.fr',
    u"telephoneNumber": "+33 211 25 687  01",
    u"facsimileTelephoneNumber": "+33 2 125899 20 01",
    u"ENTEtablissementStructRattachFctl": '',
    u"ENTEtablissementBassin": "BASSIN DU TEST",
    u"ENTServAcAcademie": "ac test",
    u"ENTStructureClasses": '',
    u"ENTStructureGroupes": [{'class': '4E3', 'group': '4E3_A'}, {'class': '4E3', 'group': '4E3_B'}],
}

etablissement3 = {
    u"ENTStructureJointure": "2517",
    u"ENTStructureUAI": "0000000TR",
    u"ENTEtablissementUAI": "0000000TR",
    u"ENTStructureSIREN": "17450234560291",
    u"ENTStructureNomCourant": "D.E.E.E.-DU ac-test",
    u"ENTStructureTypeStruct": "INSPECTIONS ACADEMIQUES",
    u"ENTEtablissementMinistereTutelle": "MINISTERE DE L'EDUCATION NATIONALE",
    u"ENTEtablissementContrat": "PU",
    u'FieldActionType': 'DELTACREATE',
    u'FieldModifiedStatus': 1,
    u"postOfficeBox": "608",
    u"street": "RUE CITE",
    u"postalCode": "18013",
    u"l": "DIJON CEDEX",
    'etab_name': '0000000TR',
    u"telephoneNumber": "+33 211 25 687  01",
    u"facsimileTelephoneNumber": "+33 2 125899 20 01",
    u"ENTEtablissementStructRattachFctl": '',
    u"ENTEtablissementBassin": "BASSIN DU TEST",
    u"ENTServAcAcademie": "ac test",
    u"ENTStructureClasses": '',
    u"ENTStructureGroupes": [{'class': '4E3', 'group': '4E3_A'}, {'class': '4E3', 'group': '4E3_B'}],
}

etablissements = {
        u'2516': etablissement,
        u'2515': etablissement2,
        u'2517': etablissement3,
        }

subject = {
        u"ENTMatJointure": '308601',
        u"ENTLibelleMatiere": 'TURC',
        u'FieldActionType': 'DELTACREATE',
        u'FieldModifiedStatus': 1
        }

subject2 = {
        u"ENTMatJointure": '308602',
        u"ENTLibelleMatiere": 'ALLEMAND',
        u'FieldActionType': 'DELTACREATE',
        u'FieldModifiedStatus': 1
        }

subject3 = {
        u"ENTMatJointure": '308603',
        u"ENTLibelleMatiere": 'ESPAGNOL',
        u'FieldActionType': 'DELTAUPDATE',
        u'FieldModifiedStatus': 1
        }

subjects = {
        '308601': subject,
        '308602': subject2,
        '308603': subject3,
        }

def test_etablissement():
    keys = set(etablissement.keys()) | set([u"_id", u'FieldFromXMLImportActionDate', u'id'])
    main(data_complet, False, allow_bulk=False, close=False)
    # simulate integration in AD
    for row in db.fetchtable('etablissement'):
        dico = {}
        dico = {'FieldActionType': row['FieldActionType'] + "_DONE"}
        db.db['etablissement'].update_one({'id': row['id']}, {'$set': dico}, False)
    main_delta(data_delta, close=False)
    result = db.fetchall('etablissement')
    list_etablissement = list(etablissements)
    for res in result:
        idx = res['id']
        if idx not in etablissements:
            continue
        print ("etablissement" + idx)
        list_etablissement.remove(idx)
        assert keys == set(res.keys())
        for key in etablissement.keys():
            assert res[key] == etablissements[idx][key], u"la valeur correspondant à : {} est différente".format(key)
    assert list_etablissement == []


def test_subject():
    keys = set(subject.keys()) | set([u"_id", u'FieldFromXMLImportActionDate', u'id'])
    main(data_complet, False, allow_bulk=False, close=False)
    # simulate integration in AD
    for row in db.fetchtable('group'):
        dico = {}
        dico = {'FieldActionType': row['FieldActionType'] + "_DONE"}
        db.db['group'].update_one({'id': row['id']}, {'$set': dico}, False)
    main_delta(data_delta, close=False)
    list_subjects = list(subjects)
    result = db.fetchall('group')
    for res in result:
        idx = res['id']
        if idx not in subjects:
            continue
        print ("subject" + idx)
        assert keys == set(res.keys())
        list_subjects.remove(idx)
        for key in subject.keys():
            assert res[key] == subjects[idx][key], u"la valeur correspondant à : {} est différente".format(key)
    assert list_subjects == []



def test_prof():
    objectid = 'ENTPersonStructRattach'
    relations = [(u'ENTAuxEnsMatiereEnseignEtab', ['etb1_anglais_lv1']),
                 (u"ENTAuxEnsClasses", ["etb1_4e3", "etb1_5e2", "etb1_5e3", "etb1_5e4", "etb1_6e1", "etb1_6e2"]),
                 (u"ENTAuxEnsClassesPrincipal", ["etb1_4e3"]),
                 (u"ENTAuxEnsGroupes", ["etb1_4e3_a"]),
                 (u"ENTAuxEnsMEF", ["etb1_4eme", "etb1_4eme_section_europeenne", "etb1_5eme", "etb1_6eme"]),
                 (u'ENTPersonFonctions', (['ENSEIGNEMENT'], ['ANGLAIS'])),
                 (u"ENTAuxEnsClassesMatieres", ["4E3", "5E2", "5E3", "5E4", "6E1", "6E2"]),
                 (u"ENTAuxEnsGroupesMatieres", ["4E3_A"]),
                 ]
    keys = set(prof.keys()) | set([u"userPassword", u"_id", u'uid', u'FieldFromXMLImportActionDate', u'id']) | set([objectid])
    for relation in relations:
        keys |= set([relation[0]])
    main(data_complet, False, allow_bulk=False, close=False)
    # simulate integration in AD
    for row in db.fetchtable('user'):
        dico = {}
        dico = {'FieldActionType': row['FieldActionType'] + "_DONE"}
        db.db['user'].update_one({'id': row['id']}, {'$set': dico}, False)
    main_delta(data_delta, close=False)
    result = db.fetchall('user', 'UserType', 'enseignant')
    list_profs = list(profs)
    for res in result:
        idx = res['id']
        if idx not in profs.keys():
            continue
        list_profs.remove(idx)
        print ("professeur" + idx)
        assert keys == set(res.keys())
        for key in prof.keys():
            assert res[key] == profs[idx][key], u"la valeur correspondant à : {} est différente".format(key)
        etab = res[objectid]
        assert isinstance(etab, ObjectId), u"{} n'est pas une relation".format(objectid)

        for relation, values in relations:
            assert relation in res
            if relation == u"ENTAuxEnsClassesMatieres":
                for idx, rel in enumerate(res[relation]):
                    assert rel['class'] == values[idx]
                    assert isinstance(rel['group'], ObjectId)
            elif relation == u"ENTAuxEnsGroupesMatieres":
                assert res[relation]['class'] == values[0]
                assert isinstance(res[relation]['group'], ObjectId)
            else:
                if isinstance(res[relation], list):
                    for idx, rel in enumerate(res[relation]):
                        assert isinstance(rel['etablissement'], ObjectId)
                        assert rel['etablissement'] == etab
                        assert rel['name'] == values[idx]
                else:
                    assert isinstance(res[relation]['etablissement'], ObjectId)
                    assert res[relation]['etablissement'] == etab
                    if isinstance(values, tuple):
                        assert res[relation]['function'] == values[0][0]
                        assert res[relation]['discipline'] == values[1][0]
                    else:
                        assert res[relation]['name'] == values[0]
    assert list_profs == []


def test_administratif():
    relations = [(u'ENTPersonFonctions', (['ORIENTATION'], ['ORIENTATION']))
                 ]
    keys = set(administratif.keys()) | set([u"userPassword", u"_id", u'uid', u'FieldFromXMLImportActionDate', u'id'])
    for relation in relations:
        keys |= set([relation[0]])
    main(data_complet, False, allow_bulk=False, close=False)
    # simulate integration in AD
    for row in db.fetchtable('user'):
        dico = {}
        dico = {'FieldActionType': row['FieldActionType'] + "_DONE"}
        db.db['user'].update_one({'id': row['id']}, {'$set': dico}, False)
    main_delta(data_delta, close=False)
    result = db.fetchall('user', 'UserType', 'administratif')
    list_administratifs = list(administratifs)
    for res in result:
        idx = res[u'ENTPersonJointure']
        if idx not in administratifs:
            continue
        print ("administratif" + idx)
        list_administratifs.remove(idx)
        assert keys == set(res.keys())
        for key in administratif.keys():
            assert res[key] == administratifs[idx][key], u"la valeur correspondant à : {} est différente".format(key)
        for relation, values in relations:
            assert relation in res
            assert isinstance(res[relation]['etablissement'], ObjectId)
            assert res[relation]['function'] == values[0][0]
            assert res[relation]['discipline'] == values[1][0]
    assert list_administratifs == []


def test_responsable():
    keys = set(responsable.keys()) | set([u"userPassword", u"_id", u'uid', u'FieldFromXMLImportActionDate', u'id'])
    main(data_complet, False, allow_bulk=False, close=False)
    # simulate integration in AD
    for row in db.fetchtable('user'):
        dico = {}
        dico = {'FieldActionType': row['FieldActionType'] + "_DONE"}
        db.db['user'].update_one({'id': row['id']}, {'$set': dico}, False)
    main_delta(data_delta, close=False)
    result = db.fetchall('user', 'UserType', 'responsable')
    list_responsables = list(responsables)
    for res in result:
        idx = res[u'ENTPersonJointure']
        if idx not in responsables:
            continue
        print ("responsable numero " + idx)
        list_responsables.remove(idx)
        assert keys == set(res.keys())
        for key in responsable.keys():
            assert res[key] == responsables[idx][key], u"la valeur correspondant à : {} est différente".format(key)
    assert list_responsables == []


def test_eleves():
    objectids = ['ENTEleveParents', 'ENTElevePere', 'ENTEleveMere', 'ENTEleveAutoriteParentale', 'ENTPersonStructRattach']
    relations = [(u'ENTEleveClasses', ['etb1_t_stl'])]
    keys = set(eleve.keys()) | set([u"userPassword", u"_id", u'uid', u'FieldFromXMLImportActionDate', u'id']) | set(objectids)
    for relation in relations:
        keys |= set([relation[0]])
    main(data_complet, False, allow_bulk=False, close=False)
    # simulate integration in AD
    for row in db.fetchtable('user'):
        dico = {}
        dico = {'FieldActionType': row['FieldActionType'] + "_DONE"}
        db.db['user'].update_one({'id': row['id']}, {'$set': dico}, False)
    main_delta(data_delta, close=False)
    result = db.fetchall('user', 'UserType', 'eleve')
    for res in result:
        idx = res[u'ENTEleveMEF']
        if idx not in eleves:
            continue
        print ("eleve numero " + idx)
        assert keys == set(res.keys())
        for key in eleve.keys():
            if key == 'ENTEleveCodeEnseignements':
                assert res[key][0] == u'010300'
                assert isinstance(res[key][1], ObjectId)
            elif key == 'ENTEleveNivFormation':
                assert res[key]['oriName'].split('_', 1)[1] == eleves[idx][key]
            else:
                assert res[key] == eleves[idx][key], u"la valeur correspondant à : {} est différente".format(key)
        for objectid in objectids:
            values = res[objectid]
            if isinstance(values, list):
                for val in values:
                    assert isinstance(val, ObjectId), u"{} n'est pas une relation".format(objectid)
                    #FIXME bon parent ?
            else:
                assert isinstance(values, ObjectId), u"{} n'est pas une relation".format(objectid)

        for relation, values in relations:
            assert relation in res
            assert isinstance(res[relation]['etablissement'], ObjectId)
            assert res[relation]['etablissement'] == res['ENTPersonStructRattach']
            assert res[relation]['name'] == values[0], u'erreur à la relation {}'.format(relation)


